﻿using System.Data.OleDb;
using System.Windows;
using System.Windows.Controls.Primitives;
using System.Windows.Input;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// 컬럼 고정 명령
        /// </summary>
        public static RoutedUICommand FreezeColumnCommand = new RoutedUICommand();

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 연결
        /// </summary>
        private OleDbConnection connection;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.connection = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=nwind.mdb");

            this.dataGrid.ItemsSource = OrderDetail.GetOrderDetailList(this.connection);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 컬럼 고정 명령 실행시 처리하기 - freezeColumnCommand_Executed(sender, e)

        /// <summary>
        /// 컬럼 고정 명령 실행시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void freezeColumnCommand_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            DataGridColumnHeader header = e.OriginalSource as DataGridColumnHeader;

            if(header.Column.IsFrozen == true)
            {
                return;
            }
            else
            {
                header.Column.DisplayIndex = this.dataGrid.FrozenColumnCount;

                this.dataGrid.FrozenColumnCount++;
            }
        }

        #endregion
    }
}